Provides access to the user's home graph including structures, devices, and the ability to control them.

A [Model Context Protocol (MCP) server](https://modelcontextprotocol.io/docs/learn/server-concepts) acts as a proxy between an external service that provides context, data, or capabilities to a Large Language Model (LLM) or AI application. MCP servers connect AI applications to external systems such as databases and web services, translating their responses into a format that the AI application can understand.

### Server Setup


You must [enable MCP servers](https://docs.cloud.google.com/mcp/enable-disable-mcp-servers) and [set up authentication](https://docs.cloud.google.com/mcp/authenticate-mcp) before use. For more information about using Google and Google Cloud remote MCP servers, see [Google Cloud MCP servers overview](https://docs.cloud.google.com/mcp/overview).

### Server Endpoints

An MCP service endpoint is the network address and communication interface (usually a URL) of the MCP server that an AI application (the Host for the MCP client) uses to establish a secure, standardized connection. It is the point of contact for the LLM to request context, call a tool, or access a resource. Google MCP endpoints can be global or regional.

The Home API MCP server has the following global MCP endpoint:

- https://home.googleapis.com/mcp

## MCP Tools

An [MCP tool](https://modelcontextprotocol.io/legacy/concepts/tools) is a function or executable capability that an MCP server exposes to a LLM or AI application to perform an action in the real world.

### Tools

The home.googleapis.com MCP server has the following tools:

| MCP Tools ||
|---|---|
| `https://developers.home.google.com/reference/home/mcp/tools_list/list_homes` | Retrieves a list of homes the user has access to. |
| `https://developers.home.google.com/reference/home/mcp/tools_list/list_home_resources` | Retrieves a list of home resources including devices. This is the primary tool for discovering what resources are available. |
| `https://developers.home.google.com/reference/home/mcp/tools_list/list_home_states` | Retrieves the current states of home resources including devices. |
| `https://developers.home.google.com/reference/home/mcp/tools_list/list_home_history` | Retrieves the history for home resources including devices. |
| `https://developers.home.google.com/reference/home/mcp/tools_list/run_home_actions` | Executes a list of actions on one or more resources. Should follow command format from list_home_resources. |
| `https://developers.home.google.com/reference/home/mcp/tools_list/list_automations` | Retrieves a list of automations for the structure. |
| `https://developers.home.google.com/reference/home/mcp/tools_list/save_automation` | Validates and converts the generated automation to a Home APIs automation and persists it. Don't retry if you encounter these errors: PERMISSION_DENIED, UNAUTHENTICATED, OUT_OF_RANGE, RESOURCE_EXHAUSTED, ALREADY_EXISTS. For other errors, retry at most three times. |

### Get MCP tool specifications


To get the MCP tool specifications for all tools in an MCP server, use the `tools/list` method. The following example demonstrates how to use `curl` to list all tools and their specifications currently available within the MCP server.

| Curl Request |
|---|
| ```bash curl --location 'https://home.googleapis.com/mcp' \ --header 'Authorization: Bearer {oauth-access-token}' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/list", "jsonrpc": "2.0", "id": 1 }' ``` |